<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useMemberStore } from '@/stores/member'
import type { Member } from '@/types/Member'

const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const refForm = ref<VForm | null>(null)
function onSubmit() {}

const loading = ref(false)
let editedIndex = -1

const memberStore = useMemberStore()

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    memberStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await memberStore.saveMembers()
  closeDialog()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    memberStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await memberStore.deleteMembers()
  closeDelete()
}

async function editItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialog.value = true
}

async function deleteItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

const addMember = () => {
  editedIndex += 1
  dialog.value = true
}

const formatDate = (dateString: string | number | Date) => {
  const date = new Date(dateString)
  const day = date.getDate()
  const month = date.getMonth() + 1
  const buddhistYear = date.getFullYear() + 543

  return `${day}/${month}/${buddhistYear}`
}
onMounted(() => {
  memberStore.getMembers()
})
</script>
<template>
  <div id="app" class="d-flex justify-center">
    <v-card
      variant="tonal"
      width="100%"
      min-width="500"
      max-width="1200"
      max-height="600"
      min-height="750"
      class="ma-3 bg-teal-darken-4"
      :elevation="18"
    >
      <v-card variant="tonal" class="ma-2 bg-teal-darken-4">
        <div
          style="
            background-color: rgb(0, 0, 0);
            color: aliceblue;
            text-align: center;
            font-size: 50px;
            font-family: Arial, Helvetica, sans-serif;
          "
        >
          Member CRUD
        </div>
        <v-container>
          <div class="d-flex justify-center">
            <v-card min-width="500" max-width="1200" height="auto" elevation="6">
              <v-table fixed-header height="550px" style="overflow: auto; width: 2000px">
                <thead>
                  <tr>
                    <th class="text-center">ID</th>
                    <th class="text-center">Name</th>
                    <th class="text-center">Tel</th>
                    <th class="text-center">Email</th>
                    <th class="text-center">Password</th>
                    <th class="text-center">Point</th>
                    <th class="text-center">Birthday</th>
                    <th class="text-center">UsedPoint</th>
                    <th class="text-center"></th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in memberStore.members" :key="item.id">
                    <td class="text-center">{{ item.id }}</td>
                    <td class="text-center">{{ item.fullName }}</td>
                    <td class="text-center">{{ item.tel }}</td>
                    <td class="text-center">{{ item.email }}</td>
                    <td class="text-center">{{ item.password }}</td>
                    <td class="text-center">{{ item.point }}</td>
                    <td class="text-center">{{ formatDate(item.birthday) }}</td>
                    <td class="text-center">{{ item.usedPoint }}</td>
                    <td class="text-center">
                      <v-btn
                        class="mx-2"
                        icon="mdi-pencil"
                        density="compact"
                        color="light-green-darken-3"
                        @click="editItem(item)"
                      >
                      </v-btn>
                      <v-btn
                        icon="mdi-trash-can"
                        density="compact"
                        color="deep-orange-darken-4"
                        @click="
                          () => {
                            deleteItem(item)
                          }
                        "
                      ></v-btn>
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-card>
          </div>
        </v-container> </v-card
      ><v-btn
        class="mt-3"
        style="align-self: flex-end; margin-left: 87.6%"
        color="green-darken-3"
        @click="addMember()"
        >Add Member</v-btn
      >
    </v-card>
  </div>
  <v-dialog v-model="dialog" persistent width="800">
    <v-card>
      <v-card-title>
        <span class="text-h5">Member Profile</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form">
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="4">
                <v-text-field
                  v-model="memberStore.editedMember.fullName"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Name"
                  prepend-icon="mdi-account-plus"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <v-text-field
                  v-model="memberStore.editedMember.tel"
                  type="number"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Tel"
                  prepend-icon="mdi-phone"
                ></v-text-field> </v-col
              ><v-col cols="12" sm="6" md="4">
                <v-text-field
                  v-model="memberStore.editedMember.email"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Email"
                  prepend-icon="mdi-email"
                ></v-text-field> </v-col
              ><v-col cols="12" sm="6" md="4">
                <v-text-field
                  v-model="memberStore.editedMember.password"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Password"
                  prepend-icon="mdi-lock"
                ></v-text-field> </v-col
              ><v-col cols="12" sm="6" md="4">
                <v-text-field
                  v-model="memberStore.editedMember.birthday"
                  type="Date"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Birthday"
                  prepend-icon="mdi-calendar"
                  date-format="DD/MM/YYYY"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <!-- <small>*indicates required field</small> -->
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDelete()">Cancel</v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm()">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<style scoped>
#app {
  background-color: #212121;
  height: 100%;
}
</style>
